/*---------------------Program Prostokt_3------------------*/
/*  Program umoliwia narysowanie prostokta w trybie       */
/*  tekstowym.                                              */
/*  Prostokt naley pokolorowa: ta ramka na niebieskim */
/*  tle.                                                    */
/*  Dugo i wysoko prostokta naley wczyta            */
/*  z klawiatury.                                           */
/*----------------------------------------------------------*/

#include <iostream.h>
#include <conio.h>
#include <stdlib.h>
#include <stdio.h>

/*---------------------------------------------------------*/
const int Kolor_Znaku = YELLOW;
const int Kolor_Tla   = BLUE;
int
   Dlugosc,			// dugo prostokata
   Wysokosc;			// wysoko prostokta
char
   Ngl,				// naronik grny lewy
   Ngp,				// naroznik grny prawy
   Ndl,				// naronik dolny lewy
   Ndp, 			// naroznik dolny prawy
   Poziom,			// linie poziome
   Pion;			// linie pionowe

/*--------------------------------------------------------*/

void Czytaj_Dane (int &Dlugosc, int &Wysokosc);
void Kolory (int Kolor_Znaku,  int Kolor_Tla);
void Prostokat (int Dlugosc, int Wysokosc,
		char Ngl, char Poziom, char Ngp,
		char Pion, char Ndl, char Ndp );

/*-------------------------------------------------------*/

void main ()			// blok gwny
{
    _setcursortype (_NORMALCURSOR);
    Kolory (WHITE, BLACK);
    clrscr ();
    Czytaj_Dane (Dlugosc, Wysokosc);
    clrscr();
    Kolory (Kolor_Znaku, Kolor_Tla);
    window(1,1,Dlugosc,Wysokosc);
    clrscr ();
    Prostokat (Dlugosc, Wysokosc, '', '', '', '', '', '');
    _setcursortype (_NOCURSOR);
    while (!kbhit())
      {
      }
//    cin.get();
}				// koniec bloku gwnego
/*-------------------------------------------------------*/

void Czytaj_Dane (int &Dlugosc, int &Wysokosc)
{				// definicja procedury Czytaj_Dane
  cout << "Podaj dugo: ";
  cin >> Dlugosc;
  cout << endl;
  cout << "Podaj wysoko: ";
  cin >> Wysokosc;
  cout << endl;
}
/*------------------------------------------------------*/

void Kolory (int Kolor_Znaku, int Kolor_Tla)
{    				// definicja procedury Kolory
  textcolor (Kolor_Znaku);
  textbackground (Kolor_Tla);
}
/*------------------------------------------------------*/

void Gora (int Dlugosc, char Ngl, char Poziom, char Ngp);
void Dol (int Dlugosc, char Ndl, char Poziom, char Ndp);
void Boki (int Dlugosc, int Wysokosc, char Pion);
/*------------------------------------------------------*/

void Prostokat (int Dlugosc, int Wysokosc,
		char Ngl, char Poziom, char Ngp,
		char Pion, char Ndl, char Ndp )
				 // definicja procedury Prostokat
{
  Gora (Dlugosc, Ngl, Poziom, Ngp);
  Boki (Dlugosc, Wysokosc, Pion);
  Dol (Dlugosc, Ndl, Poziom, Ndp);
}
/*-----------------------------------------------------*/

void Gora (int Dlugosc, char Ngl, char Poziom, char Ngp)
{
 int i;
   cout << Ngl;                 // rysowanie krawdzi grnej
   for (i = 1; i <= Dlugosc - 2; i++)
     cout << Poziom;
   cout << Ngp << endl;
}
/*-----------------------------------------------------------*/

void Dol (int Dlugosc, char Ndl, char Poziom, char Ndp)
{
  int i;
    cout << Ndl;               // rysowanie krawdzi dolnej
    for (i = 1; i <= Dlugosc - 2; i++)
      cout << Poziom;
    cout << Ndp << endl;
}
/*-----------------------------------------------------------*/

void Boki (int Dlugosc, int Wysokosc, char Pion)
{ int i, y;
    for (i = 1; i <= Wysokosc - 2; i++)	// rysowanie bokw prostokata
     { y = wherey();
       cout << Pion;
       gotoxy (Dlugosc, y);
       cout << Pion << endl;
      }
}
/*-----------------------------------------------------------*/