/*---------------------Program Prostokt_4------------------*/
/*  Program umoliwia narysowanie prostokta w trybie       */
/*  tekstowym.                                              */
/*  Prostokt naley pokolorowa: ta ramka na niebieskim */
/*  tle.                                                    */
/*  Dugo i wysoko prostokta naley wczyta            */
/*  z klawiatury.                                           */
/*----------------------------------------------------------*/

#include <iostream.h>
#include <conio.h>
#include <stdlib.h>
#include <stdio.h>

/*---------------------------------------------------------*/
const int Kolor_Znaku = YELLOW,
	  Kolor_Tla   = BLUE,
	  Min_Dlug    = 2,
	  Max_Dlug    = 79,
	  Min_Wys     = 2,
	  Max_Wys     = 24;
int
   Dlugosc,			// dugo prostokata
   Wysokosc;			// wysoko prostokta
char
   Ngl,				// naronik grny lewy
   Ngp,				// naroznik grny prawy
   Ndl,				// naronik dolny lewy
   Ndp, 			// naronik dolny prawy
   Poziom,			// linie poziome
   Pion;			// linie pionowe

/*--------------------------------------------------------*/

void Czytaj_Dane (int &Dlugosc, int &Wysokosc);
void Kolory (int Kolor_Znaku,  int Kolor_Tla);
void Prostokat (int Dlugosc, int Wysokosc,
		char Ngl, char Poziom, char Ngp,
		char Pion, char Ndl, char Ndp );

/*-------------------------------------------------------*/
void main ()			// blok gwny
{
    _setcursortype (_NORMALCURSOR);
    Kolory (WHITE, BLACK);
    clrscr ();
    Czytaj_Dane (Dlugosc, Wysokosc);
    clrscr ();
    Kolory (Kolor_Znaku, Kolor_Tla);
    window(1,1,Dlugosc,Wysokosc);
    clrscr ();
    Prostokat (Dlugosc, Wysokosc, '', '', '', '', '', '');
    _setcursortype (_NOCURSOR);
    while (!kbhit())
      {
      }

}				// koniec bloku gwnego

/*-------------------------------------------------------*/

int Czyt_Int(int Ogr_d, int Ogr_g, int x, int y)
{
  int liczba;
    do { cin >> liczba;
	 if ((liczba < Ogr_d) || (liczba > Ogr_g))
	   { gotoxy (x,y);
	     clreol();
	   }
	}
    while ((liczba < Ogr_d) || (liczba > Ogr_g));
    return (liczba);
}
/*-------------------------------------------------------------*/

void Czytaj_Dane (int &Dlugosc, int &Wysokosc)
{				// definicja procedury Czytaj_Dane
  int x, y;
  cout << "Podaj dugo: ";
  x = wherex ();
  y = wherey ();
  Dlugosc = Czyt_Int (Min_Dlug, Max_Dlug,x,y);
  cout << endl;
  cout << "Podaj wysoko: ";
  x = wherex ();
  y = wherey ();
  Wysokosc = Czyt_Int (Min_Wys, Max_Wys, x, y);
  cout << endl;
}
/*------------------------------------------------------*/


void Kolory (int Kolor_Znaku, int Kolor_Tla)
{    				// definicja procedury Kolory
  textcolor (Kolor_Znaku);
  textbackground (Kolor_Tla);
}
/*------------------------------------------------------*/

void Gora (int Dlugosc, char Ngl, char Poziom, char Ngp);
void Dol (int Dlugosc, char Ndl, char Poziom, char Ndp);
void Boki (int Dlugosc, int Wysokosc, char Pion);
/*------------------------------------------------------*/

void Prostokat (int Dlugosc, int Wysokosc,
		char Ngl, char Poziom, char Ngp,
		char Pion, char Ndl, char Ndp )
				 // definicja procedury Prostokat
{
  Gora (Dlugosc, Ngl, Poziom, Ngp);
  Boki (Dlugosc, Wysokosc, Pion);
  Dol (Dlugosc, Ndl, Poziom, Ndp);
}
/*-----------------------------------------------------*/

void Gora (int Dlugosc, char Ngl, char Poziom, char Ngp)
{
 int i;
   cout << Ngl;                 // rysowanie krawdzi grnej
   for (i = 1; i <= Dlugosc - 2; i++)
     cout << Poziom;
   cout << Ngp << endl;
}
/*-----------------------------------------------------------*/

void Dol (int Dlugosc, char Ndl, char Poziom, char Ndp)
{
  int i;
    cout << Ndl;               // rysowanie krawdzi dolnej
    for (i = 1; i <= Dlugosc - 2; i++)
      cout << Poziom;
    cout << Ndp << endl;
}
/*-----------------------------------------------------------*/

void Boki (int Dlugosc, int Wysokosc, char Pion)
{ int i, y;
    for (i = 1; i <= Wysokosc - 2; i++)	// rysowanie bokw prostokata
     { y = wherey();
       cout << Pion;
       gotoxy (Dlugosc, y);
       cout << Pion << endl;
      }
}


/*-----------------------------------------------------------*/

